"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var transforms_common_1 = require("./external/transforms-common");
var parse_1 = require("./parse");
var transform_1 = require("./transform");
function plugin(_a) {
    var t = _a.types;
    var visitor = {
        CallExpression: function (path) {
            transformNode(t, path, function () { return path.traverse(visitor); });
        }
    };
    return { visitor: visitor };
}
exports.plugin = plugin;
function transformNode(t, path, visitChildren) {
    var parseResult = parse_1.parse(t, path, visitChildren);
    if (parseResult == null)
        return;
    var transformResult = transform_1.transform(t, transforms_common_1.transformCallExpression(parseResult));
    path.replaceWith(transformResult);
}
exports.transformNode = transformNode;
